"{ Package: 'jv:vdb/tests' }"

TestCase subclass:#VDBInternalPipeStreamTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'VDB-Support-Tests'
!


!VDBInternalPipeStreamTests methodsFor:'tests'!

test_01
    | pipe |

    pipe := VDBInternalPipeStream newWithBufferSize: 3.
    pipe nextPut: $x.
    pipe nextPut: $y.

    self assert: pipe next == $x.
    self assert: pipe next == $y.

    "Created: / 07-06-2014 / 00:52:23 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_02
    | pipe |

    pipe := VDBInternalPipeStream newWithBufferSize: 3.
    pipe nextPut: $x.
    pipe nextPut: $y.
    pipe nextPut: $z.

    self assert: pipe next == $x.
    self assert: pipe next == $y.

    pipe nextPut: $a.
    pipe nextPut: $b.

    self assert: pipe next == $z.
    self assert: pipe next == $a.
    self assert: pipe next == $b.

    "Created: / 07-06-2014 / 00:53:38 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_03
    | pipe |

    pipe := VDBInternalPipeStream newWithBufferSize: 3.
    pipe nextPut: $x.
    pipe nextPut: $y.
    pipe nextPut: $z.

    self assert: pipe next == $x.
    self assert: pipe next == $y.

    pipe nextPut: $a.
    pipe nextPut: $b.

    self assert: pipe next == $z.
    self assert: pipe next == $a.

    pipe nextPut: $1.
    pipe nextPut: $2.

    self assert: pipe next == $b.
    self assert: pipe next == $1.
    self assert: pipe next == $2.

    "Created: / 07-06-2014 / 00:56:58 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_04
    | pipe |

    pipe := VDBInternalPipeStream newWithBufferSize: 3.
    pipe nextPut: $x.
    pipe nextPut: $y.

    pipe close.
    self should: [ pipe nextPut: $X ] raise: Stream writeErrorSignal.

    self assert: pipe atEnd not.
    self assert: pipe next == $x.
    self assert: pipe next == $y.
    self assert: pipe next isNil.
    self assert: pipe atEnd.

    "Created: / 07-06-2014 / 01:06:04 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!VDBInternalPipeStreamTests class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

